unit gfx_SolCtrl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, PreviewPanel,gfx_effects, Buttons;

type
  TSolCtrlForm = class(TForm)
    Label1: TLabel;
    TrackBar1: TTrackBar;
    Edit1: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    PreviewPanel1: TPreviewPanel;
    procedure TrackBar1Change(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    ResultBitmap:TBitmap;
    { Public-Deklarationen }
  end;

var
  SolCtrlForm: TSolCtrlForm;

implementation

{$R *.DFM}

procedure TSolCtrlForm.TrackBar1Change(Sender: TObject);
begin
  Edit1.Text:=IntToStr(TrackBar1.Position);
  if Caption='Solarize' then
  EffectSolarize(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,TrackBar1.Position,nil)
  else
  if Caption='Circle around' then
  EffectCircleAround(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,TrackBar1.Position,nil) else
  if Caption='FishEye' then
  EffectFishEye(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,(TrackBar1.Position+10)/ 10,nil);
  PreviewPanel1.PreviewImage.Repaint;
end;

procedure TSolCtrlForm.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#13 then begin
     TrackBar1.Position:=StrToInt(Edit1.Text);
  if Caption='Solarize' then
     EffectSolarize(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,TrackBar1.Position,nil)
  else
  if Caption='Circle around' then
  EffectCircleAround(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,TrackBar1.Position,nil) else
  if Caption='FishEye' then
  EffectFishEye(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,(TrackBar1.Position+10)/ 10,nil);
  PreviewPanel1.PreviewImage.Repaint;
  end;
end;

procedure TSolCtrlForm.FormActivate(Sender: TObject);
begin
  TrackBar1Change(self);
end;

procedure TSolCtrlForm.BitBtn1Click(Sender: TObject);
begin
  Screen.Cursor:=crHourGlass;
  try
    if not PreviewPanel1.SourceBitmap.Empty then
    begin
      if Caption='Solarize' then
      EffectSolarize(PreviewPanel1.SourceBitmap,ResultBitmap,TrackBar1.Position,nil) else
      if Caption='Circle around' then
      EffectCircleAround(PreviewPanel1.SourceBitmap,ResultBitmap,TrackBar1.Position,nil) else
      if Caption='FishEye' then
      EffectFishEye(PreviewPanel1.SourceBitmap,ResultBitmap,(TrackBar1.Position+10) / 10,nil)
    end;
  finally
  Screen.Cursor:=crDefault;
  end;
end;

procedure TSolCtrlForm.FormCreate(Sender: TObject);
begin
  ResultBitmap:=TBitmap.Create;
  TrackBar1.Max:=256;
  TrackBar1.Min:=0;
  Caption:='Solarize';
end;

end.
